function varargout = beam_bending_PSD(varargin)
% BEAM_BENDING_PSD MATLAB code for beam_bending_PSD.fig
%      BEAM_BENDING_PSD, by itself, creates a new BEAM_BENDING_PSD or raises the existing
%      singleton*.
%
%      H = BEAM_BENDING_PSD returns the handle to a new BEAM_BENDING_PSD or the handle to
%      the existing singleton*.
%
%      BEAM_BENDING_PSD('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in BEAM_BENDING_PSD.M with the given input arguments.
%
%      BEAM_BENDING_PSD('Property','Value',...) creates a new BEAM_BENDING_PSD or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before beam_bending_PSD_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to beam_bending_PSD_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help beam_bending_PSD

% Last Modified by GUIDE v2.5 27-Dec-2018 14:34:47

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @beam_bending_PSD_OpeningFcn, ...
                   'gui_OutputFcn',  @beam_bending_PSD_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before beam_bending_PSD is made visible.
function beam_bending_PSD_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to beam_bending_PSD (see VARARGIN)

% Choose default command line output for beam_bending_PSD
handles.output = hObject;

iu=getappdata(0,'unit');
L=getappdata(0,'length');

if(iu==1)
    set(handles.length_unit_text,'String','inch');
    LS=sprintf('Beam Length = %8.4g inch',L);
else
    set(handles.length_unit_text,'String','meters');
    LS=sprintf('Beam Length = %8.4g meters',L);
end

set(handles.beam_length_text,'String',LS);

set(handles.uipanel_save,'Visible','off');
set(handles.pushbutton_rainflow,'Enable','off');

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes beam_bending_PSD wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = beam_bending_PSD_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in Calculate_pushbutton.
function Calculate_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to Calculate_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

number_modes=get(handles.listbox_number_modes,'Value');

fig_num=getappdata(0,'fig_num');
      damp=getappdata(0,'damp_ratio');
        fn=getappdata(0,'fn');
      iu=getappdata(0,'unit');
      unit=iu;
      
      Q=getappdata(0,'Q');
      part=getappdata(0,'part');
      PF=part;
 
      beta=getappdata(0,'beta');
      
      LBC=getappdata(0,'LBC');
      RBC=getappdata(0,'RBC');
   
      E=getappdata(0,'E');
      I=getappdata(0,'I');    
      
      EI_term=getappdata(0,'EI_term');
      
      cna=getappdata(0,'cna');  
    
      x=str2num(get(handles.x_edit,'String')); 
      
      sq_mass=getappdata(0,'sq_mass');
      beta=getappdata(0,'beta');
      C=getappdata(0,'C');
      
      fn=fn(1:number_modes);

%
%
FS=get(handles.input_edit,'String');
%
THM=evalin('base',FS);
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%    acc_trans
%
   clear f;
   fmax=max(THM(:,1));
   nf=10000;
   n=length(fn);
%
   disp(' ');
%
   f=zeros(nf,1);
   f(1)=0.8*THM(1,1);
   for k=2:nf
        f(k)=f(k-1)*2^(1/48);
        if(f(k)>fmax)
            break;
        end    
   end
   
   [acc_trans,rv_trans,rd_trans,moment_trans]=beam_bending_trans_core(beta,C,sq_mass,x,iu,LBC,RBC,f,part,fn,damp,EI_term);
   
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
PSD_in=THM;
%
[acc_response_psd]=psd_mult_trans(PSD_in,acc_trans);
[~,accel_rms]=calculate_PSD_slopes( acc_response_psd(:,1),acc_response_psd(:,2)  );

sz=size(acc_response_psd);

fff=acc_response_psd(:,1);

%%%%%%%%%%%%%%

rv_response_psd=zeros(sz(1),sz(2));
rv_response_psd(:,1)=fff;

rd_response_psd=zeros(sz(1),sz(2));
rd_response_psd(:,1)=fff;

stress_response_psd=zeros(sz(1),sz(2));
stress_response_psd(:,1)=fff;

%%%%%%%%%%%%%%

disp_rms=0.;
velox_rms=0;
stress_rms=0.;

vflag=0;
if( rv_trans(1,2)>1.0e-12 && max(rv_trans(:,2))>=1.0e-12)
%    
    vflag=1; 
    [rv_response_psd]=psd_mult_trans(PSD_in,rv_trans);
    [~,velox_rms]=calculate_PSD_slopes(  rv_response_psd(:,1),rv_response_psd(:,2)  );
%
end   

rflag=0;
if( rd_trans(1,2)>1.0e-12 && max(rd_trans(:,2))>=1.0e-12)
%    
    rflag=1; 
    [rd_response_psd]=psd_mult_trans(PSD_in,rd_trans);
    [~,disp_rms]=calculate_PSD_slopes(  rd_response_psd(:,1),rd_response_psd(:,2)  );
%
end    
%

sflag=0;
if( moment_trans(1,2)>1.0e-12 && max(moment_trans(:,2))>=1.0e-12)
%  
    sflag=1; 
    [moment_response_psd]=psd_mult_trans(PSD_in,moment_trans);
   
    
    stress_response_psd(:,1)=        moment_response_psd(:,1);    
    stress_response_psd(:,2)=(cna/I)^2*moment_response_psd(:,2);
    
    [~,stress_rms]=calculate_PSD_slopes(  stress_response_psd(:,1),stress_response_psd(:,2)  ); 
%
end


%    
%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
freq=acc_response_psd(:,1);
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
if(unit==1)
   su='psi';
   sv='in/sec';
   dd='in'; 
else
   su='Pa';
   sv='m/sec';
   dd='mm';
%
   disp_rms=disp_rms*1000;
%
end
%
%
%%
%
disp(' ');
disp('Acceleration Response ');
out1=sprintf(' %8.4g GRMS',accel_rms);
disp(out1);
%

disp(' ');
disp(' Relative Velocity Response ');
out1=sprintf(' %8.4g %s RMS',velox_rms,sv);
disp(out1);
%%

%
disp(' ');
disp(' Relative Displacement Response ');
out1=sprintf(' %8.4g %s RMS',disp_rms,dd);
disp(out1);
%%
%
xlab=sprintf(' Frequency (Hz)');
ylab_acc=sprintf('Accel (G^2/Hz)');
%
if(unit==1)
    ylab_stress=sprintf('Stress (psi^2/Hz)');
    ylab_rv=sprintf('Rel Vel ((in/sec^2)^2/Hz)');
    ylab_rd=sprintf('Rel Disp (inch^2/Hz)');
else
    ylab_stress=sprintf('Stress (Pa^2/Hz)'); 
    ylab_rv=sprintf('Rel Vel ((m/sec^2)^2/Hz)');    
    ylab_rd=sprintf('Rel Disp (mm^2/Hz)');
end
%



%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
[~,input_rms]=calculate_PSD_slopes( THM(:,1),THM(:,2) );
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
figure(fig_num);
fig_num=fig_num+1;
setappdata(0,'fig_num',fig_num);
plot(THM(:,1),THM(:,2),acc_response_psd(:,1),acc_response_psd(:,2));
grid on;
xlabel(xlab);
ylabel(ylab_acc);
%
if(iu==1)
    out1=sprintf('Acceleration Response PSD  x=%g in',x);
else
    out1=sprintf('Acceleration Response PSD  x=%g m',x);    
end
title(out1);
%
%
s0=sprintf('Base Input %6.3g GRMS',input_rms);
s1=sprintf('Mass Response %6.3g GRMS',accel_rms);
%
legend (s0,s1); 
%    
set(gca,'MinorGridLineStyle',':','GridLineStyle',':','XScale','log',...
                     'YScale','log','XminorTick','off','YminorTick','off')
%    
    fmin=10^(floor(log10(min(freq))));
    fmax=10^(ceil(log10(max(freq))));
    
    
    ymin=10^(floor(log10(min(acc_response_psd(:,2)))));
    ymax=10^(ceil(log10(max(acc_response_psd(:,2)))));   
 
    
    if(ymax> 1e-20 && ymax<1e+20)
    
    else
        ymax=1000;
    end
    
    if(ymin> 1e-20 && ymin<1e+20)
    
    else
        ymin=1e-04;
    end    
    

    try
        xlim([fmin,fmax]);
    end
    
    try
        ylim([ymin,ymax]);
    end
    
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
if(vflag==1)

    figure(fig_num);
    fig_num=fig_num+1;
    setappdata(0,'fig_num',fig_num);
    plot(rv_response_psd(:,1),rv_response_psd(:,2));
    grid on;
    xlabel(xlab);
    ylabel(ylab_rv);
%

    if(iu==1)
        out1=sprintf('Relative Velocity Response PSD  x=%g in',x);
    else
        out1=sprintf('Relative Velocity Response PSD  x=%g m',x);    
    end
    title(out1);
%
    s1=sprintf('Response %6.3g %s RMS',velox_rms,sv);
%
    legend(s1); 
%    
    set(gca,'MinorGridLineStyle',':','GridLineStyle',':','XScale','log',...
                     'YScale','log','XminorTick','off','YminorTick','off')
%
 %
    ymin=10^(floor(log10(min(rv_response_psd(:,2)))));
    ymax=10^(ceil(log10(max(rv_response_psd(:,2))))); 
 %
    if(ymin<ymax*1.0e-05)
      ymin=ymax*1.0e-05;
    end
    axis([fmin,fmax,ymin,ymax]);
%
end

%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
if(unit==2)
    rd_response_psd(:,2)=rd_response_psd(:,2)*1.0e+06;
end
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%

if(rflag==1)

    figure(fig_num);
    fig_num=fig_num+1;
    setappdata(0,'fig_num',fig_num);
    plot(rd_response_psd(:,1),rd_response_psd(:,2));
    grid on;
    xlabel(xlab);
    ylabel(ylab_rd);
%

    if(iu==1)
        out1=sprintf('Relative Displacement Response PSD  x=%g in',x);
    else
        out1=sprintf('Relative Displacement Response PSD  x=%g m',x);    
    end
    title(out1);
%
    s1=sprintf('Response %6.3g %s RMS',disp_rms,dd);
%
    legend(s1); 
%    
    set(gca,'MinorGridLineStyle',':','GridLineStyle',':','XScale','log',...
                     'YScale','log','XminorTick','off','YminorTick','off')
%
 %
    ymin=10^(floor(log10(min(rd_response_psd(:,2)))));
    ymax=10^(ceil(log10(max(rd_response_psd(:,2))))); 
 %
    if(ymin<ymax*1.0e-05)
      ymin=ymax*1.0e-05;
    end
    axis([fmin,fmax,ymin,ymax]);
%
end
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%

if(sflag==1)
%
    figure(fig_num);
    fig_num=fig_num+1;
    setappdata(0,'fig_num',fig_num);
    plot(stress_response_psd(:,1),stress_response_psd(:,2));
    grid on;
    xlabel(xlab);
    ylabel(ylab_stress);
%
    if(iu==1)
        out1=sprintf('Stress Response PSD  x=%g in',x);
    else
        out1=sprintf('Stress Response PSD  x=%g m',x);    
    end
    title(out1);
%
    s1=sprintf('Response %7.4g %s RMS',stress_rms,su);
%
    legend(s1); 
%    
    set(gca,'MinorGridLineStyle',':','GridLineStyle',':','XScale','log',...
                     'YScale','log','XminorTick','off','YminorTick','off')
%
    ymin=10^(floor(log10(min(stress_response_psd(:,2)))));
    ymax=10^(ceil(log10(max(stress_response_psd(:,2))))); 
 %
    if(ymin<ymax*1.0e-05)
      ymin=ymax*1.0e-05;
    end
    
    axis([fmin,fmax,ymin,ymax]);

end
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%
disp(' ');
msgbox('Calculation complete.  Output written to Matlab Command Window.');      

setappdata(0,'fig_num',fig_num);    
        
setappdata(0,'acceleration',acc_response_psd);
setappdata(0,'relative_velocity',rv_response_psd);
setappdata(0,'relative_displacement',rd_response_psd);
setappdata(0,'bending_stress',stress_response_psd);
set(handles.uipanel_save,'Visible','on');


% --- Executes on button press in Return_pushbutton.
function Return_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to Return_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

delete(beam_bending_PSD);


function input_edit_Callback(hObject, eventdata, handles)
% hObject    handle to input_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of input_edit as text
%        str2double(get(hObject,'String')) returns contents of input_edit as a double


% --- Executes during object creation, after setting all properties.
function input_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to input_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function x_edit_Callback(hObject, eventdata, handles)
% hObject    handle to x_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of x_edit as text
%        str2double(get(hObject,'String')) returns contents of x_edit as a double


% --- Executes during object creation, after setting all properties.
function x_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to x_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in listbox_response.
function listbox_response_Callback(hObject, eventdata, handles)
% hObject    handle to listbox_response (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns listbox_response contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox_response


% --- Executes during object creation, after setting all properties.
function listbox_response_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox_response (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton_save.
function pushbutton_save_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_save (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

n=get(handles.listbox_response,'Value');

if(n==1)
    data=getappdata(0,'acceleration');
end
if(n==2)
    data=getappdata(0,'relative_velocity');
end
if(n==3)
    data=getappdata(0,'relative_displacement');
end
if(n==4)
    data=getappdata(0,'bending_stress');
end


output_name=get(handles.edit_output_array_name,'String');
assignin('base', output_name, data);

h = msgbox('Save Complete'); 

set(handles.pushbutton_rainflow,'Enable','on');

set(handles.uipanel_save,'Visible','on');


function edit_output_array_name_Callback(hObject, eventdata, handles)
% hObject    handle to edit_output_array_name (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_output_array_name as text
%        str2double(get(hObject,'String')) returns contents of edit_output_array_name as a double


% --- Executes during object creation, after setting all properties.
function edit_output_array_name_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_output_array_name (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton_rainflow.
function pushbutton_rainflow_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_rainflow (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


handles.s1= fatigue_toolbox;
set(handles.s1,'Visible','on');


% --- Executes on selection change in listbox_number_modes.
function listbox_number_modes_Callback(hObject, eventdata, handles)
% hObject    handle to listbox_number_modes (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns listbox_number_modes contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox_number_modes


% --- Executes during object creation, after setting all properties.
function listbox_number_modes_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox_number_modes (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
